/****************************************************************************
    
    This file is part of The Newtonator soft synth.

    Copyright (C) 2010-2011 Michael Bechard <mbechard@users.sourceforge.net>

    The Newtonator is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    The Newtonator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with The Newtonator.  If not, see <http://www.gnu.org/licenses/>.

****************************************************************************/

#ifndef NEWT_LV2_GUI_H_INCLUDED
#define NEWT_LV2_GUI_H_INCLUDED

#include <lv2gui.hpp>
#include <newt_parent_widget.h>
#include <control_enum.h>
#include "newt_lv2_instr.peg"

class NewtonatorGUI : public LV2::GUI<NewtonatorGUI>
{
    public:

    NewtonatorGUI(const std::string& URI);
    void port_event(uint32_t port, uint32_t buffer_size, uint32_t format, const void* buffer);

    protected:

    void on_parent_value_changed(ControlEnum ctrlID, double val);

    NewtParentWidget m_widget;
    bool m_notifyChange;

};

#endif // NEWT_LV2_GUI_H_INCLUDED
