/****************************************************************************
    
    This file is part of The Newtonator soft synth.

    Copyright (C) 2010-2011 Michael Bechard <mbechard@users.sourceforge.net>

    The Newtonator is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    The Newtonator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with The Newtonator.  If not, see <http://www.gnu.org/licenses/>.

****************************************************************************/

#include "newt_lv2_gui.h"
#include "config.h"

int reg()
{
    TRACE("Registering GUI class...");
    return NewtonatorGUI::register_class("http://www.wodgod.com/newtonator/1.0/gui");
}

static int _ = reg();

NewtonatorGUI::NewtonatorGUI(const std::string& URI)
{
    add(m_widget);

    m_notifyChange = true;
    m_widget.signal_value_has_changed().connect(sigc::mem_fun(*this, &NewtonatorGUI::on_parent_value_changed));
}

void NewtonatorGUI::on_parent_value_changed(ControlEnum ctrlID, double val)
{
    TRACE2("ctrl change", ctrlID, val);
    m_notifyChange = false;
    write_control((uint32_t)ctrlID, (float)val);
    m_notifyChange = true;
}

void NewtonatorGUI::port_event(uint32_t port, uint32_t buffer_size, uint32_t format, const void* buffer)
{
    if (port < p_midi_in && m_notifyChange)
        m_widget.ChangeValue((ControlEnum)port, *static_cast<const float*>(buffer));
}
